//=============================================================================
// LoginProtector.
//
// Copyright(c) 2003, Winged Unicorn.
//=============================================================================
class LoginProtector extends ServerActor
	config(MCoopServerTools);


struct LoginOpts
{
	var string InName;
	var string InClass;
	var class<PlayerPawn> SpawnClass;
	var string InSkin;
	var byte InTeam;
	var string InPassword;
	var int PawnType;
};

var(LoginProtector) globalconfig int DelayTime;
var(LoginProtector) globalconfig int BanTime;
var(LoginProtector) globalconfig int TimeOut;

// the Options request
var LoginOpts LoginOptions;

var string PlayerIP;
var int TimeLeft, TimeOutLeft;
var bool bAllowLogin;


function bool Increment()
{
	TimeLeft += DelayTime;
	TimeOutLeft = TimeOut;

	if ( TimeLeft > BanTime )
		return True;

	return False;
}

// "It's the final countdown..."
auto state CountDown
{
	function Timer()
	{
		if ( TimeOutLeft <= 0 )
			Destroy();
		else
			TimeOutLeft--;

		if ( TimeLeft <= 0 )
			bAllowLogin = True;
		else
			TimeLeft--;
	}

Begin:
	TimeOutLeft = TimeOut;
	TimeLeft = DelayTime;
	bAllowLogin = False;
	SetTimer(1, True);
}

defaultproperties
{
				DelayTime=5
				BanTime=60
				TimeOut=60
}
